<script lang="ts">
import Vue from 'vue';
import { cloneDeep } from 'lodash';
import { SlpSpinner } from '../common/index.vue';
import FeaturesProductsCategoryCards from './features-product-category-cards.vue';
import FeaturesCtaSection from './features-cta-section.vue';
import { processFeatureObjectHelper } from '~/lib/processFeaturesHelper';

export default Vue.extend({
  name: 'FeaturesContent',
  components: {
    FeaturesProductsCategoryCards,
    FeaturesCtaSection,
    SlpSpinner,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
    filter: {
      type: Object,
      required: true,
    },
    contentConfig: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      filteredData: [],
      isLoading: true,
    };
  },
  watch: {
    filter(newFilter: any) {
      this.isLoading = true;
      this.featuresByCategory(this.data, newFilter);
    },
  },
  beforeMount() {
    this.featuresByCategory(this.data, this.filter);
  },
  methods: {
    scrollToTop() {
      window.scrollTo({ top: 0, behavior: 'smooth' });
    },
    featuresByCategory(data: any, filter: any) {
      const clonedData = cloneDeep(data.features);
      this.filteredData = clonedData.map((item: any) => {
        return {
          ...item,
          features: item.features.map((feature: any) => {
            const itemCopy = processFeatureObjectHelper(
              feature,
              this.contentConfig,
            );
            itemCopy.with_opacity = this.processItemFilter(itemCopy, filter);
            return itemCopy;
          }),
        };
      });
      setTimeout(() => {
        this.isLoading = false;
      }, 1000);
    },
    processItemFilter(item: any, filter: any) {
      switch (filter.plan) {
        case 'free':
          return !item.isFree;
        case 'premium':
          return !item.isPremium;
        case 'ultimate':
          return !item.isUltimate;
        default:
          return false;
      }
    },
  },
});
</script>

<template>
  <div class="features-content">
    <section
      v-for="(category, index) in filteredData"
      :id="category.slug"
      :key="index"
    >
      <div v-if="category.features.length">
        <SlpTypography
          tag="h2"
          variant="heading4-bold"
          class="features-product-category__category slp-mb-64"
          :data-aos="contentConfig.header_animation"
          :data-aos-duration="contentConfig.header_animation_duration"
        >
          {{ category.name }}
        </SlpTypography>
        <FeaturesProductsCategoryCards
          :class="{ 'features-content__products-category--loading': isLoading }"
          class="features-content__products-category"
          :data="category.features"
          :column-size="contentConfig.column_size"
          :current-category="category.name"
          :image-base-path="`https://about.gitlab.com/images/feature_page/screenshots/`"
        />
        <FeaturesCtaSection />
      </div>
    </section>
    <SlpSpinner :is-loading="isLoading" />
  </div>
</template>

<style scoped lang="scss">
.features-content {
  margin-bottom: $spacing-96;
  margin-top: $spacing-48;
  padding-left: $spacing-4;
  padding-right: $spacing-4;
  position: relative;
  display: block;

  &__missing-features-button {
    padding: 0;
    border: none;
    background: none;
    cursor: pointer;
    color: $color-text-link-100;
    font-size: $text-body-2;
    transition: all 0.5s ease;

    &:hover {
      filter: brightness(80%);
    }
  }

  &__products-category {
    padding: 0;
    opacity: 1;
    transition: opacity 0.3s ease-in-out;

    @media (min-width: $breakpoint-md) {
      margin-left: -$spacing-16;
    }

    &--loading {
      opacity: 0;
    }
  }

  &__btn {
    color: inherit;
    font-weight: bold;
    transition: all 0.5s ease-in-out;

    &:hover {
      text-decoration: underline;
    }
  }
}
</style>
